
#include "stdafx.h"
#include "AstralFrame.h"
#include "resource.h"
#include ".\astralframe.h"

// CAstralFrame

CAstralFrame::CAstralFrame()
{
}

CAstralFrame::~CAstralFrame()
{
}

BEGIN_MESSAGE_MAP(CAstralFrame, CFrameWnd)
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_WM_CLOSE()
	ON_WM_ERASEBKGND()
	ON_WM_CREATE()

	ON_AUTO_UPDATE_CONTROL_BAR(ID_FILE_ASSEL)
END_MESSAGE_MAP()

BOOL CAstralFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if (!CFrameWnd::PreCreateWindow(cs)) return false;

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	return true;
}

BOOL CAstralFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext)
{
	if (!vw.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW, CRect(), this, AFX_IDW_PANE_FIRST, pContext))
		return false;
	return true;
}

void CAstralFrame::ActivateFrame(int nCmdShow)
{
	CFrameWnd::ActivateFrame(SW_MINIMIZE);
}

void CAstralFrame::OnFileExit()
{
	ShowWindow(SW_HIDE);
}

void CAstralFrame::OnClose()
{
	ShowWindow(SW_HIDE);
}

BOOL CAstralFrame::OnEraseBkgnd(CDC* pDC)
{
	return true;
}

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

int CAstralFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (false
		|| !wndAsselDock.Create("Astral selection", this, ID_FILE_ASSEL, 0 |WS_CHILD |WS_VISIBLE |CBRS_RIGHT |CBRS_SIZE_DYNAMIC)
	) {
		return -1;
	}

	if (false
		|| !wndStatusBar.Create(this)
		|| !wndStatusBar.SetIndicators(indicators, sizeof(indicators)/sizeof(UINT))
	) {
		return -1;
	}

	EnableDocking(CBRS_ALIGN_ANY);

	wndAsselDock.EnableDocking(CBRS_ORIENT_VERT);
	DockControlBar(&wndAsselDock, AFX_IDW_DOCKBAR_RIGHT);

	return 0;
}
