
#pragma once

#include "DebDock.h"
#include "MMapDock.h"
#include "CustomDock.h"
#include "TailerDock.h"
#include "MonitorFrame.h"

class CIDEFrame : public CMDIFrameWnd
{
public:
	// 
	CDebDock wndDebDock;
	CMMapDock wndMMapDock;
	CCustomDock wndCustDock;
	CFRDock wndFRDock;
	CTailerDock wndTailerDock;
	CMonitorFrame wndMonitor;

	CStatusBar wndStatusBar;

	// 
	CFont fontFixedPitch;

	// 
	CIDEFrame();
	// 
	virtual ~CIDEFrame();

	// 
	virtual void PostNcDestroy() { }

protected:
	// 
	DECLARE_MESSAGE_MAP()
public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
public:
	afx_msg void OnFileClose();
	afx_msg void OnClose();
	virtual void ActivateFrame(int nCmdShow = -1);
	afx_msg void OnDestroy();
};
