
#pragma once

#include "CustomVw.h"
#include "FRDock.h"
#include "MenuBarXP.h"
#include "ToolBarXP.h"

class CCustomFrame : public CFrameWnd
{
public:
	// 
	CCustomVw vw;
	// 
	CStatusBar wndStatusBar;
	// 
	CToolBar wndToolBar;

	// 
	CMenuBarXP wndMenuBar;
	CReBar wndRebar;

	// 
	CCustomFrame();
	//
	virtual ~CCustomFrame();
	// 
	bool Avail()
	{
		return (GetSafeHwnd() != NULL);
	}

	// 
	virtual void PostNcDestroy() { }

protected:
	// 
	DECLARE_MESSAGE_MAP()
public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
protected:
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
public:
	afx_msg void OnFileExit();
	afx_msg void OnClose();
	afx_msg void OnEditSelectAll();
	LRESULT OnPopMessageString(WPARAM wParam, LPARAM lParam);
	LRESULT OnSetMessageString(WPARAM wParam, LPARAM lParam);
};
