
#pragma once

#include "CustReport.h"

class CCustomVw : public CListView
{
public:
	// 
	typedef CCustReport Data;

	// 
	DWORD iNextNumber;
	// 
	bool fAlwaysTop, fCapture;

	// 
	CCustomVw();
	// 
	virtual ~CCustomVw();

	// 
	void Reset();

	// 
	void Message(LPCTSTR pszMessage, LPCSTR pszSrc, int severity, int &refid);
	// 
	CCustReport *FindReport(int refid, bool invalidate);
	// 
	void SelEntry(int i);

	// 
	virtual void PostNcDestroy() { }

protected:
	// 
	CFont m_fontLv;
	// 
	CImageList m_photo;

	// 
	DECLARE_MESSAGE_MAP()

public:
	virtual void OnInitialUpdate();
protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnPopupScripto();
	afx_msg void OnButtonClear();
	afx_msg void OnButtonAlwaysTop();
	afx_msg void OnUpdateButtonAlwaysTop(CCmdUI *pCmdUI);
	afx_msg void OnButtonPlay();
	afx_msg void OnUpdateButtonPlay(CCmdUI *pCmdUI);
	afx_msg void OnPopupScriptStat();
	afx_msg void OnLvnDeleteitem(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnItemActivate(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnItemchanged(NMHDR *pNMHDR, LRESULT *pResult);
};
