
#pragma once

namespace SNES {

struct Instruction {
	LPCSTR name;
	BYTE addr, length, cycles, branch;
};

extern Instruction instruc[256];
extern Instruction instapu[256];

typedef enum PInstructionKind {
	pikNo,
	pikJxx,
	pikSub,
	pikRet,
}	PInstructionKind;

PInstructionKind GetPikOf(BYTE v);

typedef enum PISubKind {
	piskNo,
	piskSubShort,
	piskSubLong,
	piskRetShort,
	piskRetLong,
	piskRetInterrupt,
};

PISubKind GetPiskOf(BYTE v);

BYTE SizeOfOp(BYTE opec, BYTE ps);

BYTE SpecOfOp(BYTE opec);
BYTE SpecOfOpfaster(BYTE opec);

};