
#pragma once

#define MAX_SCRIPTO 10U

enum {
	SCRLETS_OK,
	SCRLETS_UNLOADED,
	SCRLETS_BROKEN,
	SCRLETS_INTERNAL_ERR,
	SCRLETS_UNKNOWN,
};

class CScriptolet
{
public:
	// 
	CComQIPtr<IActiveScript> pUnkScript;
	// 
	COleDispatchDriver cUnkCommander;
	// 
	DISPID cDispID[2];
	// 
	bool fReady;
	// 
	CString strScriptoName;

	// 
	virtual ~CScriptolet()
	{
		Close();
	}
	// 
	bool Load(CComBSTR bstrOLEScript, CComBSTR bstrText, CString strName);
	// 
	bool LoadFile(CComBSTR bstrOLEScript, LPCTSTR pszFileName);
	// 
	void Close();
	// 
	int GetState();

};

class CScriptoServer
{
public:
	// 
	CScriptolet scrlet[MAX_SCRIPTO];

	// 
	bool Sync();
	// 
	void CodeBreakNow(DWORD addr);
	void CodeBreakPostProcNow(DWORD addrOld, DWORD addrNew);
	void Close();

};
