
#pragma once

#include "TailerVw.h"
#include "DSP2DevVw.h"

class CTailerFrame : public CFrameWnd
{
	//  
	DECLARE_MESSAGE_MAP()

public:
	// 
	CToolBar wndToolBar;
	// 
	CTailerVw vw;
	CDSP2DevVw vw2;

	// 
	CTailerFrame();
	virtual ~CTailerFrame();
	virtual void PostNcDestroy() { }

protected:
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg BOOL OnButtonTilemap(UINT nID);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnUpdateButtonTilemap(CCmdUI *pCmdUI);
	LRESULT OnPopMessageString(WPARAM wParam, LPARAM lParam);
	LRESULT OnSetMessageString(WPARAM wParam, LPARAM lParam);
};


