
%include "macros.mac"

SECTION .bss
NEWSYM fprintf_pc_offset, resd 1
NEWSYM fprintf_status, resd 1
NEWSYM fprintf_infoloc, resd 1
NEWSYM fprintf_switch, resd 1
NEWSYM fprintf_apu_pc, resd 1
NEWSYM fprintf_clear_offset, resd 1
NEWSYM fprintf_clear_size, resd 1
NEWSYM fprintf_sa1_pc, resd 1
NEWSYM fprintf_sa1_switch, resd 1
NEWSYM fprintf_sa1_status, resd 1

SECTION .text
EXTSYM romdata, initaddrl
EXTSYM spcRam

EXTSYM fprintf_interrupt_service_c
NEWSYM fprintf_interrupt_service
    pushad

	lea eax,[esi-1]
	sub eax,[initaddrl]
    mov [fprintf_pc_offset],eax
    mov [fprintf_status],dl
    call fprintf_interrupt_service_c

    popad
    ret

EXTSYM fprintf_intSA1_service_c
NEWSYM fprintf_intSA1_service
    pushad

	lea eax,[esi-1]
	sub eax,[initaddrl]
    mov [fprintf_sa1_pc],eax
    mov [fprintf_status],dl
    call fprintf_intSA1_service_c

    popad
    ret

EXTSYM fprintf_init_service_c, fprintfc_init_call
NEWSYM fprintf_init_service
	mov byte[fprintfc_init_call],1
	ret
    pushad
    call fprintf_init_service_c
    popad
    ret

EXTSYM fprintf_display_c
NEWSYM fprintf_display
    pushad
    call fprintf_display_c
    popad
    ret

EXTSYM fprintf_intAPU_service_c
NEWSYM fprintf_intAPU_service
	pushad
	lea eax,[ebp-1]
	sub eax,spcRam
	mov [fprintf_apu_pc],eax

	call fprintf_intAPU_service_c
	popad
	ret

EXTSYM fprintf_clear_spc_c
NEWSYM fprintf_clear_spc
	pushad
	sub eax,spcRam
	mov [fprintf_clear_offset],eax
	mov [fprintf_clear_size],dl

	call fprintf_clear_spc_c
	popad
	ret
