
%include "macros.mac"

EXTSYM memtabler8,memtabler16

SECTION .bss
NEWSYM fprintfi_addr, resd 1
NEWSYM fprintfi_read, resd 1

SECTION .text
NEWSYM fprintfi_read_mem8
	pushad
	xor ecx,ecx
	xor ebx,ebx
    mov cx,[fprintfi_addr]
    mov bl,[fprintfi_addr+2]
    call dword near [memtabler8+ebx*4]

    mov [fprintfi_read],al
    popad
	ret
NEWSYM fprintfi_read_mem16
	pushad
	xor ecx,ecx
	xor ebx,ebx
    mov cx,[fprintfi_addr]
    mov bl,[fprintfi_addr+2]
    call dword near [memtabler16+ebx*4]

    mov [fprintfi_read],eax
    popad
	ret
NEWSYM fprintfi_read_mem32
	pushad

	xor eax,eax
	mov ax,[fprintfi_addr]
	mov esi,eax

	xor eax,eax
	mov al,[fprintfi_addr+2]
	mov edi,eax

	mov ecx,esi
	mov ebx,edi
    call dword near [memtabler16+ebx*4]
    mov [fprintfi_read],ax

	lea ecx,[esi+2]
	mov ebx,edi
    call dword near [memtabler16+ebx*4]
    mov [fprintfi_read+2],ax

    popad
	ret
